# -*- coding: utf-8 -*-
from django.http import HttpResponse
import os.path, commands
import mimetypes
from django.contrib.auth.decorators import login_required
from django.core.servers.basehttp import FileWrapper

from jmb.openvpn.models import Certificate

def get_status_openvpn():
    piddir="/var/run/openvpn.server-tcp.status"
    stato = "SPENTO"
    if os.path.exists(piddir):
        stato="ACCESO"
    return stato

@login_required
def onoff_openvpn(request):
    stato = get_status_openvpn()
    if stato == "ACCESO":
        status, output = commands.getstatusoutput("sudo /etc/init.d/openvpn stop")
    else:
        status, output = commands.getstatusoutput("sudo /etc/init.d/openvpn start")
    return HttpResponse("OK")

@login_required
def restart_openvpn(request):
    status, output = commands.getstatusoutput("sudo /etc/init.d/openvpn restart")
    return HttpResponse("OK")

@login_required
def download_certificate(request, object_id):
    TAR_PATH = settings.OVPN_TAR_PATH
    EXT_CERT = settings.OVPN_EXT_CERT

    try:
        c = Certificate.objects.get(pk=object_id)
    except:
        return HttpResponse('<h1>Certificate not found</h1>')

    if request.user.is_staff:
        cert_name = "%s.%s" % (c.user.username, EXT_CERT)
        f_path = os.path.join(TAR_PATH, cert_name)

        if os.path.exists(f_path):
            ff = open(f_path)
            # generate the file
            response = HttpResponse(ff.read(), content_type='application/%s' % EXT_CERT)
            response['Content-Disposition'] = 'attachment; filename=%s' % cert_name
            return response
        else:
            return HttpResponse('<h1>Certificate not found</h1>')
    else:
        return HttpResponse("<h1>Access Denied</h1>")
